From aeab83b524ce33302a6144fe053d1c4e13a3e436 Mon Sep 17 00:00:00 2001
From: Thomas Loimer <thomas.loimer@tuwien.ac.at>
Date: Tue, 28 Jan 2020 22:56:40 +0100
Subject: Reject text or ellipse angles beyond -2pi to 2pi, #76

In fact, generously extend the allowed range to -7 to 7.
Sane applications, e.g., xfig, certainly keep the angles within one revolution.
---
 fig2dev/object.h | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

diff --git a/fig2dev/object.h b/fig2dev/object.h
index 2917f81..7c97bb9 100644
--- a/fig2dev/object.h
+++ b/fig2dev/object.h
@@ -91,7 +91,8 @@ typedef struct f_ellipse {
 #define INVALID_ELLIPSE(e)	\
 	e->type < T_ELLIPSE_BY_RAD || e->type > T_CIRCLE_BY_DIA ||	\
 	COMMON_PROPERTIES(e) || e->direction != 1 && e->direction != 0 || \
-	e->radiuses.x < 0 || e->radiuses.y < 0
+	e->radiuses.x < 0 || e->radiuses.y < 0 || \
+	e->angle < -7. || e->angle > 7.
 
 typedef struct f_arc {
 	int			type;
@@ -240,7 +241,7 @@ typedef struct f_text {
 	t->type < T_LEFT_JUSTIFIED || t->type > T_RIGHT_JUSTIFIED ||	\
 	t->font < DEFAULT || t->font > MAX_PSFONT ||			\
 	t->flags < DEFAULT || t->flags >= 2 * HIDDEN_TEXT ||		\
-	t->height < 0 || t->length < 0
+	t->height < 0 || t->length < 0 || t->angle < -7. || t->angle > 7.
 
 typedef struct f_control {
 	double			lx, ly, rx, ry;	/* used by older versions*/
-- 
2.30.2

